package PodHTML2;

use strict;
use warnings;
use utf8;

my $rcsid = '$Id: PodHTML2.pm,v 1.6 2007/09/16 18:54:42 pippijn Exp $';

use base qw/PodHTML/;

sub view_head1 {
   my ($self, $item) = @_;
   $item->title->present ($self), "\n\n",
   $item->content->present ($self)
}

sub view_seq_link {
   my ($self, $item) = @_;
   my ($title, $link) = split '\|', $item, 2;
   if ($link) {
      return "<a href='$link'>$title</a>"
   } else {
      return "<a href='$title'>$title</a>"
   }
}

sub view_item {
   my ($self, $item) = @_;
   my $title;
   if ($item->title =~ /^L</) {
      $title = $item->title;
      $title =~ s/L<(.+)>/- $1/;
      $self->xmlise (\$title);
      $title = $self->view_seq_link ($title);
   } else {
      $title = $item->title;
      $self->xmlise (\$title);
   }

   '<li>', ($item->title eq '*' ? '<b>( * )</b> ' : '<b>' . $title . '</b> '), $item->content->present ($self), '</li>'
}

sub view_for {
   my ($self) = @_;
   for ($_[1]->format) {
      /^date/ and return "<b>" . $_[1]->text . "</b>";
      return $self::SUPER->view_for ($_[1]);
   }
}

=head1 AUTHOR

Copyright © 2007 Pippijn van Steenhoven

=head1 LICENSE

This library is free software, you can redistribute it and/or modify
it under the terms of the GNU General Public License version 3 or later.

=cut

1
