/**
 * mymemo.h: Data structures for account information.
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 *
 * Portions of this file were derived from sources bearing the following license:
 * Copyright © 2005-2006 Atheme Development Group
 * Rights to this code are as documented in doc/pod/license.pod.
 *
 * $Id: mymemo.h,v 1.6 2007/09/16 18:54:42 pippijn Exp $
 */

#ifndef ACCOUNT_MYMEMO_H
#define ACCOUNT_MYMEMO_H

/* memo status flags */
enum mymemo_flag
{
  MEMO_READ    = 1 << 0,
  MEMO_CHANNEL = 1 << 1
};

/* struct for account memos */
struct mymemo_t : zero_initialised
{
  typedef std::vector<mymemo_t *> list_type;

  unsigned status;

  unsigned mu_index; // index used in myuser_t::memo_vector

  char sender[NICKLEN];
  char text[MEMOLEN];
  time_t sent;
};

/* memoserv rate limiting parameters */
#define MEMO_MAX_NUM   5
#define MEMO_MAX_TIME  180

#endif
