/**
 * svsignore.h: Data structures for account information.
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 *
 * Portions of this file were derived from sources bearing the following license:
 * Copyright © 2005-2006 Atheme Development Group
 * Rights to this code are as documented in doc/pod/license.pod.
 *
 * $Id: svsignore.h,v 1.6 2007/09/16 18:54:42 pippijn Exp $
 */

#ifndef ACCOUNT_SVSIGNORE_H
#define ACCOUNT_SVSIGNORE_H

/* services ignore struct */
struct svsignore_t : zero_initialised
{
  unsigned index;

  char *mask;
  time_t settime;
  char *setby;
  char *reason;
};

/* svsignore.c */
typedef indexing_vector<svsignore_t> svsignore_vector;
E svsignore_vector svs_ignore_list;

E svsignore_t *svsignore_find (user_t *user);
E svsignore_t *svsignore_add (char *mask, char *reason);
E void svsignore_delete (svsignore_t *svsignore);

#endif
