/**
 * authcookie.h: Remote authentication ticket management.
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 *
 * Portions of this file were derived from sources bearing the following license:
 * Copyright © 2005 Atheme Development Group
 * Rights to this code are as documented in doc/pod/license.pod.
 *
 * $Id: authcookie.h,v 1.4 2007/09/16 18:54:42 pippijn Exp $
 */

#ifndef AUTHCOOKIE_H
#define AUTHCOOKIE_H

struct authcookie_t : zero_initialised
{
  char *ticket;
  myuser_t *myuser;
  time_t expire;
  node_t node;
};

E void authcookie_init (void);
E authcookie_t *authcookie_create (myuser_t *mu);
E authcookie_t *authcookie_find (char *ticket, myuser_t *myuser);
E void authcookie_destroy (authcookie_t *ac);
E void authcookie_destroy_all (myuser_t *mu);
E bool authcookie_validate (char *ticket, myuser_t *myuser);
E void authcookie_expire (void *arg);

#endif
