/**
 * crypto.h: Modular cryptography support.
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented under doc/pod/gplicense.pod.
 *
 * $Id: crypto.h,v 1.2 2007/09/16 18:54:42 pippijn Exp $
 */

#ifndef ERMYTH_CRYPTO_H
#define ERMYTH_CRYPTO_H

namespace crypto
{
  struct handler
  {
    static bool loaded;

    handler ()
    {
      loaded = true;
    }

    virtual ~handler ()
    {
      loaded = false;
    }
    
    virtual char const *crypt (char const * const str, char const * const salt);
  };
  
  E bool verify_password (char const * const uinput, char const * const pass);
  E char *gen_salt (void);
} // namespace crypt

#define FACREG_TYPE crypto::handler
#define FACREG_TYPE_NAME "crypto_handler"
#define FACREG_TYPE_IS_ABSTRACT
#include <ermyth/factory_reg.h>

/* global.C */
E crypto::handler *crypter;

#endif
