/**
 * database.h: Modular database support
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in doc/pod/gplicense.pod.
 *
 * $Id: database.h,v 1.3 2007/09/16 18:54:42 pippijn Exp $
 */

#ifndef ERMYTH_DATABASE_H
#define ERMYTH_DATABASE_H

#include <ermyth/factory.h>

namespace database
{
  struct handler
  {
    /* global.C */
    static bool loaded;

    handler ()
    {
      loaded = true;
    }
  
    virtual ~handler ()
    {
      loaded = false;
    }
  
    virtual void save () = 0;
    virtual void load () = 0;
  };
}

#define FACREG_TYPE database::handler
#define FACREG_TYPE_NAME "database_handler"
#define FACREG_TYPE_IS_ABSTRACT
#include <ermyth/factory_reg.h>

/* global.C */
E database::handler *backend;

/* Check the database for (version) problems common to all backends */
E void db_check (void);

#endif
