#ifndef FACREG_TYPE
# error "You must define FACREG_TYPE before including this file."
#endif

#ifndef FACREG_TYPE_NAME
# define FACREG_TYPE_NAME #FACREG_TYPE
#endif

#ifndef FACREG_INTERFACE_TYPE
# define FACREG_INTERFACE_TYPE FACREG_TYPE
#endif

#ifdef FACREG_TYPE_IS_ABSTRACT
/**
 * Install a specialisation of Factory's default factory type,
 * so that we won't try to instantiate a FACREG_TYPE object.
 * For the non-abstract case we will rely on the default create_hook
 * implementation (or a client-installed specialisation).
 */
namespace factory
{
  /**
   * create_hook specialisation to install a no-op
   * factory. Intended for use with abastract types.
   */
  template<>
  struct create_hook<FACREG_INTERFACE_TYPE, FACREG_TYPE>
  {
    typedef FACREG_INTERFACE_TYPE * result_type;
    typedef FACREG_TYPE actual_type;

    static result_type create()
    {
      return 0;
    }
  };
} // namespace factory
#endif // FACREG_TYPE_IS_ABSTRACT

namespace
{
// we must not include this more than once per compilation unit
#ifndef FACTORY_REG_CONTEXT_DEFINED
#define FACTORY_REG_CONTEXT_DEFINED
  /**
   * A unique (per Context/per compilation unit) space to assign
   * a bogus value for classloader registration purposes (see
   * the classloader docs for a full description of how this
   * works).
   */
  template<typename Context>
  struct factory_reg_context
  {
    factory_reg_context()
    {
      if (placeholder == true)
        asm ("");  // weird workaround, just to reference the var.
    }

    /**
     * Placeholder variable for automatic factory
     * registration.
     */
    static bool placeholder;
  };
#endif // !FACTORY_REG_CONTEXT_DEFINED

  /**
   * Placeholder variable for automatic factory registration.
   */
  template<>
  bool /* do we need here??? */
  factory_reg_context<FACREG_TYPE>::placeholder = (
    ::factory::register_factory<FACREG_INTERFACE_TYPE> (
      std::string (FACREG_TYPE_NAME),
      ::factory::create_hook<
        FACREG_INTERFACE_TYPE,
        FACREG_TYPE
      >::create
    ),
  true);
  // DAMN, that's fugly!
} // anon namespace

#ifdef FACREG_TYPE_IS_ABSTRACT
# undef FACREG_TYPE_IS_ABSTRACT
#endif
#undef FACREG_TYPE
#undef FACREG_INTERFACE_TYPE
#undef FACREG_TYPE_NAME
