/**
 * event.h: Event stuff.
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 *
 * Portions of this file were derived from sources bearing the following license:
 * Copyright © 2005 atheme.org.
 * Rights to this code are as documented in doc/pod/license.pod.
 *
 * $Id: event.h,v 1.4 2007/09/16 18:54:42 pippijn Exp $
 */

#ifndef EVENT_H
#define EVENT_H

typedef void EVH (void *);

/* event list struct */
struct ev_entry : zero_initialised
{
  EVH *func;
  void *arg;
  char const *name;
  time_t frequency;
  time_t when;
  bool active;
};

E struct ev_entry event_table[MAX_EVENTS];
E char const *last_event_ran;

E unsigned int event_add (char const * const name, EVH * func, void *arg, time_t when);
E unsigned int event_add_once (char const * const name, EVH * func, void *arg, time_t when);
E void event_run (void);
E time_t event_next_time (void);
E void event_delete (EVH * func, void *arg);
E unsigned int event_find (EVH * func, void *arg);

#endif
