/**
 * i18n.h: This is the header which includes all of the internationalization stuff.
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 *
 * Portions of this file were derived from sources bearing the following license:
 * Copyright © 2005 William Pitcock et al.
 * Rights to this code are documented in doc/pod/license.pod.
 *
 * $Id: i18n.h,v 1.4 2007/09/16 18:54:42 pippijn Exp $
 */

#ifndef __ATHEME_INTL_H__
#define __ATHEME_INTL_H__

#ifdef ENABLE_NLS
# include <locale.h>
# include <libintl.h>
# define _(String) gettext (String)
# ifdef gettext_noop
#  define N_(String) gettext_noop (String)
# else
# define N_(String) (String)
# endif
#else
# define _(x)     	(x)
# define N_(x)    	(x)
# define ngettext(s1, sn, n) ((n) == 1 ? (s1) : (sn))
#endif

#endif
