/**
 * match.h: String matching
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 *
 * Portions of this file were derived from sources bearing the following license:
 * Copyright © 2003-2004 E. Will et al.
 * Copyright © 2005-2006 Atheme Development Group
 * Rights to this code are as defined in doc/pod/license.pod.
 *
 * $Id: match.h,v 1.5 2007/09/22 14:27:26 pippijn Exp $
 */

#ifndef _MATCH_H
#define _MATCH_H

/* cidr.c */
E int match_ips (char const * const mask, char const * const address);
E int match_cidr (char const * const mask, char const * const address);

E int match (char const * const mask, char const * const name);
E char *collapse (char *);

/* regex_create() flags */
#define AREGEX_ICASE	1	/* case insensitive */

E regex_t *regex_create (char *pattern, int flags);
E char *regex_extract (char *pattern, char **pend, int *pflags);
E bool regex_match (regex_t * preg, char *string);
E bool regex_destroy (regex_t * preg);

#endif
