/**
 * util.h: Various utility functions.
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 * $Id: numeric.h,v 1.1 2007/09/22 14:27:26 pippijn Exp $
 */

#ifndef NUMERIC_H
#define NUMERIC_H

extern int itoa (uint32_t n, char *buf, int buflen);
extern int itoa (uint64_t n, char *buf, int buflen);

inline int
itoa (int32_t n, char *buf, int buflen)
{
  *buf = '-';
  buf += (n < 0);
  uint32_t u = n < 0 ? -n : n;
  return itoa (u, buf, buflen - (n < 0));
}

inline int
itoa (int64_t n, char *buf, int buflen)
{
  *buf = '-';
  buf += (n < 0);
  uint64_t u = n < 0 ? -n : n;
  return itoa (u, buf, buflen);
}

template<typename IntType, int N>
inline int
itoa (IntType n, char (&buf)[N])
{
  return itoa (n, buf, N);
}

/* reverse of atoi() */
template<typename T>
static inline char *
itoa (T num)
{
  static char ret[20];
  itoa (num, ret);
  return ret;
}

#endif
