/**
 * util.h: Various utility functions.
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 * $Id: template.h,v 1.1 2007/09/22 14:27:26 pippijn Exp $
 */

#ifndef TEMPLATE_H
#define TEMPLATE_H

#define MATH_COMPILE_MACROS

namespace math
{
  template<long a, long b>
  struct add
  {
    static const long ret = a + b;
  };

  template<long a, long b>
  struct sub
  {
    static const long ret = a - b;
  };

  template<long a, long b>
  struct mul
  {
    static const long ret = a * b;
  };

  template<long a, long b>
  struct div
  {
    static const long ret = a / b;
  };

#ifdef MATH_COMPILE_MACROS
#define ADD(a, b) math::add<a, b>::ret
#define SUB(a, b) math::sub<a, b>::ret
#define MUL(a, b) math::mul<a, b>::ret
#define DIV(a, b) math::div<a, b>::ret
#endif
} // namespace math

#endif
