#include "tst-main.C"

int
exec_tests ()
{
  char const plain[] = "Some plaintext buffer";
  char const expected_code[] = "U29tZSBwbGFpbnRleHQgYnVmZmVyA";

  char plainbuf[30] = { 0 };
  char code[30] = { 0 };
  char *codeptr = 0;
  char *codebuf = new char[30];

  base64::encoder enc;
  base64::decoder dec;

  assert (enc.encode (58) == 54);
  assert (enc.encode (64) == 61);
  assert (enc.encode (65) == 61);

  enc.encode (plain, code);
  assert (!strcmp (code, expected_code));

  enc.encode (plain, &codeptr);
  assert (!strcmp (codeptr, expected_code));

  enc.encode (plain, codebuf);
  assert (!strcmp (codebuf, expected_code));

  dec.decode (code, strlen (code), plainbuf);
  assert (!strcmp (plainbuf, plain));

  return 0;
}
