/**
 * cs_ping.C: Some module TODO
 *
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Rights to this code are as documented in COPYING.
 *
 *
 * Portions of this file were derived from sources bearing the following license:
 * Copyright © 2007 Atheme Development Group
 * Rights to this code are as documented in doc/pod/license.pod.
 *
 * $Id: cs_ping.C,v 1.4 2007/09/22 14:27:27 pippijn Exp $
 */

#include "atheme.h"
#include <ermyth/module.h>

static char const rcsid[] = "$Id: cs_ping.C,v 1.4 2007/09/22 14:27:27 pippijn Exp $";

REGISTER_MODULE ("chanserv/ping", false, "The Ermyth Team <http://ermyth.xinutec.org>");

static void cs_cmd_ping (sourceinfo_t *si, int parc, char *parv[]);

command_t const cs_ping = { "PING", "Verifies network connectivity by responding with pong.", AC_NONE, 0, cs_cmd_ping };

E cmdvec cs_cmdtree;

bool
_modinit (module *m)
{
  cs_cmdtree << cs_ping;

  return true;
}

void
_moddeinit ()
{
  cs_cmdtree >> cs_ping;
}

static void
cs_cmd_ping (sourceinfo_t *si, int parc, char *parv[])
{
  command_success_nodata (si, "Pong!");
  return;
}
