# Copyright © 2006 William Pitcock, et al.
# All rights reserved.
#
# Rights to this code are documented in doc/poddoc/license.pod

use strict;
use warnings FATAL => 'all';
use utf8;

my @lines = do { open my $fh, "<names/default" or die "names/default: $!"; <$fh> };

my %begin_sym = ( );
my %medial_sym = ( );
my %end_sym = ( );
my $which = 0;

my $begin_sym_cnt = 0;
my $medial_sym_cnt = 0;
my $end_sym_cnt = 0;

my $begin_syms = "";
my $medial_syms = "";
my $end_syms = "";

for my $line (@lines) {
   chomp $line;
   
   if ($line =~ /^%/) {
      $which++;
      next;
   }
   
   $begin_sym{$line} = $line if $which == 0;
   $medial_sym{$line} = $line if $which == 1;
   $end_sym{$line} = $line if $which == 2;
};

for my $sym (keys %begin_sym) {
   $begin_syms .= "\t\"$sym\",\n";
   $begin_sym_cnt++;
};

for my $sym (keys %medial_sym) {
   $medial_syms .= "\t\"$sym\",\n";
   $medial_sym_cnt++;
};

for my $sym (keys %end_sym) {
   $end_syms .= "\t\"$sym\",\n";
   $end_sym_cnt++;
};

my $tab = <<EOF;
/* Copyright © 2006 William Pitcock, et al.
 * All rights reserved.
 *
 * Rights to this code are documented in doc/poddoc/license.pod
 *
 * Autogenerated by gen_namegen_tab.pl. Do not modify!
 */
#ifndef _NAMEGEN_H
#define _NAMEGEN_H

char const * const begin_sym[] = {
$begin_syms};

#define BEGIN_SYM_SZ $begin_sym_cnt

char const * const medial_sym[] = {
$medial_syms};

#define MEDIAL_SYM_SZ $medial_sym_cnt

char const * const end_sym[] = {
$end_syms};

#define END_SYM_SZ $end_sym_cnt

#endif
EOF
open my $fh, '>namegen_tab.h';
utf8::encode $tab;
print $fh $tab;
close $fh;
