#!/bin/sh
#
# Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
# Copyright © 2005-2006 Atheme Development Group
# Rights to this code are documented in doc/pod/license.pod.
#
# This file generates version.C.
# Stolen from ircd-ratbox.
#
# $Id: version.sh,v 1.6 2007/09/22 14:27:30 pippijn Exp $
#

package=ermyth

echo "Extracting $package/src/version.C..."

if test -r version.C.last
then
   generation=`sed -n 's/^char const generation\[\] = \"\(.*\)\";/\1/p' < version.C.last`
   if test ! "$generation" ; then generation=0; fi
else
   generation=0
fi

generation=`expr $generation + 1`

uname=`uname`

osinfo=`uname -a`;

creation=`date | \
awk '{if (NF == 6) \
         { print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
         { print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

buildid=`echo "\$Revision: 1.6 $" | \
	awk '{ print $2 }'`;

cat >version.C <<!SUB!THIS!
/*
 * Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team
 * Copyright © 2005-2007 Atheme Development Group
 * Rights to this code are documented in doc/pod/license.pod.
 *
 * This file contains version information.
 * Autogenerated by version.sh.
 */

// declaring them extern or the compiler might optimise them out entirely
extern char const website[];
extern char const generation[];
extern char const creation[];
extern char const platform[];
extern char const version[];
extern char const revision[];
extern char const osinfo[];
extern char const * const infotext[];

char const website[]    = "http://ermyth.xinutec.org";
char const generation[] = "$generation";
char const creation[]   = "$creation";
char const platform[]   = "$uname";
char const version[]    = "$1";
char const osinfo[]     = "$osinfo";

char const * const infotext[] =
{
   "Ermyth IRC Services --",
   "Copyright © 2007 Pippijn van Steenhoven / The Ermyth Team",
   "Copyright © 2005-2007 Atheme Development Group",
   " ",
   "All rights reserved.",
   " ",
   "Ermyth IRC Services is free software: you can redistribute it and/or modify",
   "it under the terms of the GNU General Public License as published by",
   "the Free Software Foundation, either version 3 of the License, or",
   "(at your option) any later version.",
   " ",
   "This program is distributed in the hope that it will be useful,",
   "but WITHOUT ANY WARRANTY; without even the implied warranty of",
   "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the",
   "GNU General Public License for more details.",
   " ",
   "You should have received a copy of the GNU General Public License",
   "along with this program. If not, see <http://www.gnu.org/licenses/>.",
   " ",
   "The authors can be reached via e-mail to <pip88nl@gmail.com>",
   " ",
   "Currently Ermyth's core group consists of the following developers,",
   "in nick-alphabetical order:",
   "  pippijn, Pippijn van Steenhoven <pip88nl@gmail.com>",
   " ",
   "The following people have contributed blood, sweat and tears to",
   "this release:",
   "  alambert, Alex Lambert <alambert@quickfire.org>",
   "  beu, Elfyn McBratney <elfyn.mcbratney@gmail.com>",
   "  Dianora, Diane Bruce <db@db.net>",
   "  gxti, Michael Tharp <gxti@partiallystapled.com>",
   "  jilles, Jilles Tjoelker <jilles@stack.nl>",
   "  kog, Greg Feigenson <kog@epiphanic.org>",
   "  kuja, Jeff Katz <jeff@katzonline.net>",
   "  lu_zero, Luca Barbato <lu_zero@gentoo.org>",
   "  nenolod, William Pitcock <nenolod@nenolod.net>",
   "  pfish, Patrick Fish <pofish@gmail.com>",
   "  terminal, Theo Julienne <admin@ozweb.nu>",
   "  Trystan, Trystan Scott Lee <trystan@nomadirc.net>",
   "  w00t, Robin Burchell <viroteck@viroteck.net>",
   "  zparta, Jens Holmqvist <zparta@hispan.se>",
   " ",
   "Visit our website at http://ermyth.xinutec.org/",
   0,
};
!SUB!THIS!
