package Ermyth::Web::Controller::Help;

use strict;
use warnings FATAL => 'all';
use utf8;

my $rcsid = '$Id: Help.pm,v 1.4 2007/07/28 17:26:27 pippijn Exp $';

use base 'Catalyst::Controller';

sub default : Private {
   my ($self, $c) = @_;

   $c->stash->{current} = "/help";
   $c->stash->{pod} = $c->model('Pod')->html ("help.pod");
   $c->stash->{template} = 'static.tt'
}

sub maintainance : Local {
   my ($self, $c) = @_;

   $c->stash->{current} = "/help/maintainance";
   $c->stash->{pod} = $c->model('Pod')->html ("help/account.pod", 'maintainance');
   $c->stash->{template} = 'static.tt'
}

sub profile : Local {
   my ($self, $c) = @_;

   $c->stash->{current} = "/help/profile";
   $c->stash->{pod} = $c->model('Pod')->html ("help/account.pod", 'profile');
   $c->stash->{template} = 'static.tt'
}

sub send : Local {
   my ($self, $c) = @_;

   $c->stash->{current} = "/help/send";
   $c->stash->{pod} = $c->model('Pod')->html ("help/memo.pod", 'send');
   $c->stash->{template} = 'static.tt'
}


=head1 AUTHOR

Copyright © 2007 Pippijn van Steenhoven

=head1 LICENSE

This library is free software, you can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

1
