package Ermyth::Web::Controller::Root;

use strict;
#use warnings FATAL => 'all';
use utf8;

my $rcsid = '$Id: Root.pm,v 1.5 2007/07/28 17:26:27 pippijn Exp $';

use base 'Catalyst::Controller';

__PACKAGE__->config->{namespace} = '';

sub default : Private {
   my ($self, $c) = @_;
   
   $c->stash->{current} = "/";
   $c->res->redirect ($c->config->{base} . "/home");
}

sub end : ActionClass('RenderView') {
   my ($self, $c) = @_;
   $self->{menu} = "";
   $self->rendermenu ($c, $c->config->{menu});
   $c->stash->{menu} = $self->{menu};
}

sub home : Local {
   my ($self, $c) = @_;

   $c->stash->{current} = "/home";
   $c->stash->{pod} = $c->model('Pod')->html ("home.pod");
   $c->stash->{template} = 'static.tt'
}

sub rendermenu {
   my ($self, $c, $menu) = @_;
   $self->{menu} .= "<ul>";
   for my $menuitem (@$menu) {
      $menuitem->{level} ||= 0;
      next if     $c->session->{authcookie} and $menuitem->{level} < 0;
      next if not $c->session->{authcookie} and $menuitem->{level} > 0;
      if ($menuitem->{menu}) {
         $self->{menu} .= '<li><a href="' . $c->uri_for ($menuitem->{href}) . '">'
            . ($menuitem->{href} eq $c->stash->{current}
               ? $menuitem->{title} . "&#xab;"
               : $menuitem->{title});
         $self->rendermenu ($c, $menuitem->{menu});
         $self->{menu} .= '</a></li>';
      } else {
         $self->{menu} .= '<li><a href="' . $c->uri_for ($menuitem->{href}) . '">'
            . ($menuitem->{href} eq $c->stash->{current}
               ? $menuitem->{title} . "&#xab;"
               : $menuitem->{title})
            .'</a></li>';
      }
   }
   $self->{menu} .= "</ul>";

   ()
}


=head1 AUTHOR

Copyright © 2007 Pippijn van Steenhoven

=head1 LICENSE

This library is free software, you can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

1
